/*
Copyright (c) 2008-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: Contains CCircularBufferExample class. 
*/



/**
 @file
*/
#ifndef __CIRCULARBUFFEREXAMPLE_H__
#define __CIRCULARBUFFEREXAMPLE_H__

#include <e32cons.h>

/**
Demonstrates the following uses of the Symbian platform circular buffer API:

- Creating a circular buffer.
- Adding elements to the circular buffer
- Removing elements from the circular buffer
*/
class CCircularBufferExample: public CBase
	{
public:
	static CCircularBufferExample* NewL();
	~CCircularBufferExample();
 	void CircularBufferOfIntsL();
	void CircularBufferOfMyObjectsL();
	void CircularBufferOfRClasssL();

private:
	CCircularBufferExample();
	void ConstructL();
private:
	/** Pointer to console interface */
	CConsoleBase* iConsole;
	};

/**
Demonstrates a simple class containing a simple buffer and methods 
- create a text buffer using new value
- to set value to buffer
- retrieve buffer's value
*/	

class TMyClass
	{
public:
	TMyClass();
	TMyClass(const TDesC& aDes);
	void SetBuf(const TDesC& aDes);
	const TDesC& GetBuf();
private:
	// Simple buffer to hold text
	TBufC<16> iBuf;
 };



#endif //__CIRCULARBUFFEREXAMPLE_H__
